%soheil mahmoodi&
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%% etelat avliyhe %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clc
clear all
Q=input('Qmax=');
P=input('p=');
n1=input('arze dahaneha=');
t=input('zekhamat payeha=');
Hup=input('roghom sathe ab dar bala dast=');
Hbedup=input('roghom sathe bastar dar bala dast=');
V=input('shibe badanhe dar payab vertical sarriz=');
H=input('shibe badanhe dar payab horizental sarriz=');
Hbedd=input('roghom sathe bastar dar \ain dast sarriz=');
s1=input('shib shut ba hasbe darsad=');
Hshut=input('roghom sathe shot dar pain dast=');
nn=input('zarib manning=');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%% mosahbe head tarahi %%%%%%%%%%%%%%%%%%%%%%%%%%%%
Hd=Hup-P-Hbedup;
He=Hd;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%% mohasebe C%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if (P/Hd)>1.33;
    %meghdar c barazesh dadhe shode ast%
    C1=((-0.04386)*((P/Hd)^(-0.6147)))+2.226;
else (P/Hd)<1.33;
    disp('cavitason rokh midahad va bayad meghdar p ra bishtar konim');
end
q1=C1*(He)^(1.5);                     
V0=((q1)/(P+Hd));
H0=((V0)^2)/(2*9.81);
disp(sprintf('Head sorat dar sarriz oggi=%0.2f',H0));
He1=Hd+H0;
 disp(sprintf('head tarahi =%0.2f',He1));
 ii=(He1/Hd);
 C=C1*((-.1404*(ii)^(-16.03))+1.149);
 disp(sprintf('zarib C sarriz =%0.2f',C));
 q=C*(He1)^(1.5);
 disp(sprintf('debi dar vahed arze sariz =%0.2f',q));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%  mohasebeh parametrhaye saarriz   %%%%%%%%%%%%%%%%%%%%

Le=(Q/((C*He1^1.5)));
  disp(sprintf('Tole moaser sarriz=%0.2f',Le));
N=(Le/n1);
N1=ceil(N);
disp(sprintf('Tedad dahaneha =%0.2f',N1));
L1=Le+2*He1*((N-1)*0.01+0.1);
L=(L1+(N-1)*t);
  disp(sprintf('Tole dahane sarriz =%0.2f',L));
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  j=(H0/Hd);
K=-2.347*(power(j,2))+0.3116*j+0.502;
disp(sprintf('parametr (K) sarriz =%0.2f',K));
n=3.341*(power(j,2))-0.8848*j+1.887;
disp(sprintf('parametr (n) sarriz =%0.2f',n));
i=(H0/He1);
xc=(((-0.006114*i^3)+0.00027*i^3-0.01032*i+0.244))*(He1);
disp(sprintf('parametr (xc) sarriz =%0.2f',xc));

yc=(((-0.002093*i^3)-0.005172*i^3-0.01426*i+0.1056))*(He1);
disp(sprintf('parametr (yc) sarriz =%0.2f',yc));

Rr1=(((0.003218*i^3)+0.00932*i^3-0.05583*i+0.4298))*(He1);
disp(sprintf('parametr (R2) sarriz =%0.2f',Rr1));

Rr2=(((-0.001094*i^3)+0.0003061*i^3-0.0125*i+0.223))*(He1);
disp(sprintf('parametr (R1) sarriz =%0.2f',Rr2));

format short
X=sym('X');
y=-K*Hd*(power(X,n))*(power(Hd,-n));
s=diff(y,1,X);
Xc=solve((s==(-1)*(V/H)),X);
Xc=double(Xc);
disp(sprintf('enteha ofoghi bakhshe monhani sarriz =%0.2f',Xc));

Yc=subs(y,X,Xc);
Yc=double(Yc);
disp(sprintf('enteha ghaem bakhshe monhani sarriz =%0.2f',Yc));

t1=Hbedup+P-Hbedd;
x1=solve((-1*Yc==-K*Hd*(power(X,n))*(power(Hd,-n))),X);
x1=round(x1);
e=0:0.5:Xc;
Y=-K*Hd*(power(e,n))*(power(Hd,-n));
figure(1)
plot(e,Y)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t2=0:0.5:L;
[e,t2]=meshgrid(e,t2);
z=-1*K*Hd*(e.^n)*(Hd)^(-1*n);
figure(2)
mesh(e,t2,z)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%  mohasebat shut  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
y1=sym('y1');
y1=solve((t1+He1==y1+((q)^2)/(2*9.81*power(y1,2))),y1>0);
y11=min(double(real(sort(y1))));
disp(sprintf('ertefa ab dar ebteda  shut =%0.2f',y11))
R1=(L*y11)/(L+2*y11);
v11=(q/y11);
Sf=((nn^2*(v11)^2)/R1^(4/3));
disp(sprintf('ofte enerji(Sf) dar shut shut =%0.2f',Sf))
R11=0.305*10^((v11+6.4*Hd+4.88)/(3.6*Hd+19.52));
disp(sprintf('shoa enhena panje sarriz =%0.2f',R11))
teta=atand(s1);
disp(sprintf('zaviyhe nesbat be ofogh shut =%0.2f',teta))
deltay=Hbedd-Hshut;
deltax=(deltay/s1);
L11=((deltax)^2+(deltay)^2)^(0.5);
disp(sprintf('tole masire shut =%0.2f',L11))

y2=sym('y2');
y2=solve((y11*(cosd(teta))^2+((q)^2)/(2*9.81*power(y11,2))+deltay==Sf*L11+y2*(cosd(teta))^2+((q)^2)/(2*9.81*power(y2,2))),y2>0);
y22=min(double(real(sort(y2))));
disp(sprintf('ertefa ab dar enteha  shut =%0.2f',y22))
FB=0.6+0.03*v11*(y11)^(1/3);
disp(sprintf('ertefa divare shut =%0.2f',FB))
m=(deltay/deltax);
oy=0:1:L;
ox=0:1:(deltax);
c1=deltax-(ox*m);
figure(3)
plot(ox,c1)
figure(4)
[ox,oy]=meshgrid(ox,oy);
z1=deltax-(ox*m);
mesh(ox,oy,z1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
V22=(q/y22*cosd(teta));
disp(sprintf('SOrat dar voridi hozhehe aramaesh =%0.2f',V22));
Y111=(q/V22);
disp(sprintf('paresh hidrolici avalihe =%0.2f',Y111));
FR1=V22/((9.81*Y111)^(0.5));
disp(sprintf('Nnumber froud aval =%0.2f',FR1));
Y222=-0.5*Y111*(1-(1+8*FR1^2)^(0.5));
disp(sprintf('paresh hidrolici sanaviyhe =%0.2f',Y222));
Fa=double(0.1*(V22+Y222));
disp(sprintf('ertefa divare hozhehe aramesh=%0.2f',Fa));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %stilling Basin USBR 2
if (FR1>4.5)&&(V22>18.3);
    disp('%%%%%%%%%%%%%%%%   stilling Basin  USBR2             %%%%%%%%%%%%%%%%%%%');
    Lbasin=(Y222)*(0.0002491*((FR1)^3)-0.02559*((FR1)^2)+0.5047*(FR1)+1.854);
    W1=(Y111);
    disp(sprintf('arze Baffle Piers(boolok partab konadhe(W1)) =%0.2f',W1));
    S1=(Y111);
    disp(sprintf('favasel Baffle Piers(boolok partab konadhe(S1) = %0.2f',S1));
    h1=(Y111);
    disp(sprintf('ertefa Baffle Piers(boolok partab konadhe(h1) =%0.2f',h1));
     W2=(0.15*Y222);
    disp(sprintf('arze Baffle Piers(astanhe entehai dandanhedar(W2)) =%0.2f',W2));
    S2=(0.15*Y222);
    disp(sprintf('favasel Baffle Piers(astanhe entehai dandanhe(s2) = %0.2f',S2));
    h2=(0.2*Y222);
    disp(sprintf('ertefa Baffle Piers(astanhe entehai dandanhe(h2) =%0.2f',h2));
    disp(sprintf('Lbasin USBR 2= %0.2f',Lbasin));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %stilling Basin USBR 3
if (4.5<FR1)&&(FR1<9)&&(V22<18.3);
    disp('%%%%%%%%%%%%%%%%       stilling Basin  USBR2            %%%%%%%%%%%%%%%');
    Lbasin=(Y222)*(0.006222*((FR1)^3)-0.1058*((FR1)^2)+0.1761*(FR1)+2.792);
    disp(sprintf('Lbasin USBR 3=: %0.2f',Lbasin));
    W1=(Y111);
    disp(sprintf('arze Baffle Piers(boolok partab konadhe(W1)) =%0.2f',W1));
    S1=(Y111);
    disp(sprintf('favasel Baffle Piers(boolok partab konadhe(S1) = %0.2f',S1));
    h1=(Y111);
    disp(sprintf('ertefa Baffle Piers(boolok partab konadhe(h1) =%0.2f',h1));
    M=(0.8*Y222);
    disp(sprintf('Fsele boolok ebteda va enteha =%0.2f',M));
    h3=(Y111*(0.1693*(FR1)+0.5729));
disp(sprintf('ertefa boolok aram koonadhe(h3) =%0.2f',h3));
    S2=(0.75*h3);
     disp(sprintf('favesl boolok aram koonadhe(S2) =%0.2f',S2));
     W2=(0.75*h3);
     disp(sprintf('arze boolok aram koonadhe(W2) =%0.2f',W2));
     tb=(0.2*h3);
      disp(sprintf('zekhamat boolok aram koonadhe(tb) =%0.2f',tb));
      h4=(Y111*(0.06214*(FR1)+0.9314));
      disp(sprintf('ertefa astanhe enteha(h4) =%0.2f',h4));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %stilling Basin USBR 4 
                 
if (2.5<FR1)&&(FR1<4.5);
    disp('%%%%%%%%%%%        stilling Basin  USBR2       &&&&&&&&&&&&&&&');
    Lbasin=(Y222)*(0.02523*((FR1)^3)-0.4928*((FR1)^2)+3.02*(FR1)+0.03825);
    disp(sprintf('Lbasin USBR 4=: %0.2f',Lbasin));
     W1=(Y111);
    disp(sprintf('arze Baffle Piers(boolok partab konadhe(W1)) =%0.2f',W1));
    S1=(2.5*Y111);
    disp(sprintf('favasel Baffle Piers(boolok partab konadhe(S1) = %0.2f',S1));
    h1=(2*Y111);
    disp(sprintf('ertefa Baffle Piers(boolok partab konadhe(h1) =%0.2f',h1));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%% Two stage Stilling Basin %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 disp('%%%%%%%%%%%%%%%%   Two stage Stilling Basin           %%%%%%%%%%%%%%%%%%%');
La1=6*Y222;
disp(sprintf('tole hozche aramesh aval =%0.2f',La1))
va2=(q/Y222);
Y333=sym('Y333');
Y333=solve((Y222+((va2)^2/(2*9.81))==Y333+((q)^2)/(2*9.81*power(Y333,2))),Y333>0);
Y333=min(double(real(sort(Y333))));
disp(sprintf('ertefa ab dar ebteda  hozche dovom =%0.2f',Y333))
va22=(q/Y333);
FRa1=(va22)/((9.81*Y333)^(0.5));
Y444=-0.5*Y333*(1-(1+8*FRa1^2)^(0.5));
disp(sprintf('ertefa ab dar enteah  hozche dovom =%0.2f',Y444))
La2=3*Y444;
disp(sprintf('tole hozche aramesh aval =%0.2f',La2))

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RRR=((Y222-Y444)/(Y222));
disp(sprintf('ESTEFADHE AZ HOZHE ARAMESH DO MARHLEHI ERTEFA AB RA KAM MIKONAD =%0.2f',RRR))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%









 

